import * as mc from "@minecraft/server"
const { world, system } = mc;
import { QIDB } from "./QIDB.js"


export const LootDatabase = new QIDB('rvme_l', 10, 1)

export class LootChest {
    constructor() { }
    /**@param {mc.ItemStack[]} itemStacks @param {mc.Player} player */
    create(player, itemStacks) {
        const { location, dimension } = player;
        const serial_number = player.getDynamicProperty('serial_number') || 0
        player.setDynamicProperty('serial_number', serial_number + 1)

        this.key = player.id + "_" + serial_number
        LootDatabase.set(this.key, itemStacks)

        const lootChest = dimension.spawnEntity("rm:loot_chest", location)

        lootChest.nameTag = player.name + "'s Loot Chest"
        lootChest.setDynamicProperty(`identifier`, this.key)

        lootChest.runCommand('effect @s resistance infinite 225')
        lootChest.runCommand('effect @s regeneration infinite 225')
    }
    /**@param {mc.Entity} entity */
    fromEntity(entity) {
        const identifier = entity.getDynamicProperty('identifier')
        if (!LootDatabase.has(identifier)) return;
        entity.remove()
        system.runTimeout(() => LootDatabase.delete(identifier), 5)
        return LootDatabase.get(identifier)
    }
}